Codeforces 797E Array Queries

来源:互联网 发布:网络教育官网 编辑:程序博客网 时间:2024/06/05 06:44

题目

a is an array of n positive integers, all of which are not greater than n.

You have to process q queries to this array. Each query is represented by two numbers p and k. Several operations are performed in each query; each operation changes p to p + ap + k. There operations are applied until p becomes greater than n. The answer to the query is the number of performed operations.

输入

The first line contains one integer n (1 ≤ n ≤ 100000).

The second line contains n integers — elements of a (1 ≤ ai ≤ n for each i from 1 to n).

The third line containts one integer q (1 ≤ q ≤ 100000).

Then q lines follow. Each line contains the values of p and k for corresponding query (1 ≤ p, k ≤ n).

输出

Print q integers, ith integer must be equal to the answer to ith query.

样例

input
3
1 1 1
3
1 1
2 1
3 1
output
2
1
1

注意事项

Consider first example:

In first query after first operation p = 3, after second operation p = 5.

In next two queries p is greater than n after the first operation.

题解

我用了Codeforces官方Tutorial的做法.因为我觉得它的写法已经很简单易懂了,就不具体补充了。具体如下:

There are two possible solutions in O( n2 ) time.

First of them answers each query using simple iteration — changes p to
p+ap+k for each query until p becomes greater than n, as stated in
the problem. But it is too slow.

Second solution precalculates answers for each p and k:

if p+ap+k>n, then ansp,k=1, else ansp,k=ansp+ap+k,k+1.
But this uses O(n2) memory and can be done in O(n2) time.

Now we can notice that if k<n, then second solution will use only O(n)time
and memory, and if kn , then first solution will do not more than n
operations on each query. So we can combine these two solutions.

Time complexity: O(nn)

代码

#include<bits/stdc++.h>using namespace std;const int maxn=100000+10;const int maxm=317;int a[maxn],n,q,dp[maxn][maxm];vector<int> G[maxn];void init(void){    for(int j=1;j<maxm;j++)    {        for(int i=n;i>=1;i--)        {            if(i+j+a[i]>n)                dp[i][j]=1;            else                dp[i][j]=1+dp[i+j+a[i]][j];        }    }}int solve(int p,int k){    int cnt=0;    while(p<=n)    {        p=a[p]+p+k;        cnt++;    }    return cnt;}int main(void){    int p,k;    cin>>n;    for(int i=1;i<=n;i++)        scanf("%d",&a[i]);    init();//precalculation:dp    cin>>q;    while(q--)    {        scanf("%d%d",&p,&k);        if(k>315)//use brute force            printf("%d\n",solve(p,k));        else            printf("%d\n",dp[p][k]);    }    return 0;}
原创粉丝点击